//+------------------------------------------------------------------+
//|                                                       K3M_M3.mq4 |

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 30
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

//---- input parameters
extern int api=9;
//---- buffers
double ADXBuffer[];
double YellowBuffer[];
double RedBuffer[];
double PlusDiBuffer[];
double MinusDiBuffer[];
double PlusSdiBuffer[];
double MinusSdiBuffer[];
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(8);
//---- indicator buffers
   SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, 4);
   SetIndexBuffer(0,YellowBuffer);
   SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, 3);
   SetIndexBuffer(1,RedBuffer);
   SetIndexBuffer(2,ADXBuffer);
   SetIndexBuffer(3,PlusDiBuffer);
   SetIndexBuffer(4,MinusDiBuffer);
   SetIndexBuffer(5,PlusSdiBuffer);
   SetIndexBuffer(6,MinusSdiBuffer);
   SetIndexBuffer(7,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("K3M_M3("+api+")");
   SetIndexLabel(0,"K");
   SetIndexLabel(1,"+DI");
   SetIndexLabel(2,"-DI");
//----
   SetIndexDrawBegin(0,api);
   SetIndexDrawBegin(1,api);
   SetIndexDrawBegin(2,api);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average Directional Movement Index                               |
//+------------------------------------------------------------------+
int start()
  {
   double pdm,mdm,tr;
   double price_high,price_low;
   int    starti,i,counted_bars=IndicatorCounted();
//----
   i=Bars-2;
   PlusSdiBuffer[i+1]=0;
   MinusSdiBuffer[i+1]=0;
   if(counted_bars>=i) i=Bars-counted_bars-1;
   starti=i;
//----
   while(i>=0)
     {
      price_low=Low[i];
      price_high=High[i];
      //----
      pdm=price_high-High[i+1];
      mdm=Low[i+1]-price_low;
      if(pdm<0) pdm=0;  // +DM
      if(mdm<0) mdm=0;  // -DM
      if(pdm==mdm) { pdm=0; mdm=0; }
      else if(pdm<mdm) pdm=0;
           else if(mdm<pdm) mdm=0;
      //----   
      double num1=MathAbs(price_high-price_low);
      double num2=MathAbs(price_high-Close[i+1]);
      double num3=MathAbs(price_low-Close[i+1]);
      tr=MathMax(num1,num2);
      tr=MathMax(tr,num3);
      //---- counting plus/minus direction
      if(tr==0) { PlusSdiBuffer[i]=0; MinusSdiBuffer[i]=0; }
      else      { PlusSdiBuffer[i]=100.0*pdm/tr; MinusSdiBuffer[i]=100.0*mdm/tr; }
      //----
      i--;
     }
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
//---- apply EMA to +DI
   for(i=0; i<=limit; i++)
      PlusDiBuffer[i]=iMAOnArray(PlusSdiBuffer,Bars,api,0,MODE_EMA,i);
//---- apply EMA to -DI
   for(i=0; i<=limit; i++)
      MinusDiBuffer[i]=iMAOnArray(MinusSdiBuffer,Bars,api,0,MODE_EMA,i);
//---- Directional Movement (DX)
   i=Bars-2;
   TempBuffer[i+1]=0;
   i=starti;
   while(i>=0)
     {
      double div=MathAbs(PlusDiBuffer[i]+MinusDiBuffer[i]);
      if(div==0.00) TempBuffer[i]=0;
      else TempBuffer[i]=100*(MathAbs(PlusDiBuffer[i]-MinusDiBuffer[i])/div);
      i--;
     }
//---- ADX is exponential moving average on DX
   for(i=0; i<limit; i++)
      ADXBuffer[i]=iMAOnArray(TempBuffer,Bars,api,0,MODE_EMA,i);
      
      
   i=Bars-2;
   YellowBuffer[i]=0;
   RedBuffer[i]=0;
   TempBuffer[i+1]=0;
   i=starti;
   while(i>=0)
     {

if(PlusDiBuffer[i]>=20&&MinusDiBuffer[i]<=20) YellowBuffer[i]=30;
else
YellowBuffer[i]=0;
if(PlusDiBuffer[i]<=20&&MinusDiBuffer[i]>=20) RedBuffer[i]=20;  
else
RedBuffer[i]=0;

      i--;
     }      
      
      
//----
   return(0);
  }
//+------------------------------------------------------------------+


